/* Exxon  price power acd burr
*/


library cml, co, pgraph;
#include cml.ext;
#include co.ext
#include pgraph.ext;
CMLset;
coset;
graphset;
#include highfreq.dec;
#include highfreq.ext;
#include svdDeflt.ext;
#INCLUDE gammafm.src;
#INCLUDE svd_h.src;
#include tacd.dec;
#include tacd.src;
globalpsi = {};

#include dtyfcacd.src;


@============@
@ The following GLOBALS must be identical for all models tested to ensure comparability @

let number_of_bins = 20;                 /*number of bins for histogram plot of z changed from binwidth: j.g. 9.11.99 */
let lagorder = 50;                       /*Lags for autocorrelation plot:                      */
let conf_interval = 0.9;                 /*90 % confidence interval for histogram plot         */

@ end common section @
@============@

/*******************   TO BE ADAPTED FOR EACH DATA SET    *******************/

loadm datamatrix = ibm_t;
OUTPUT file      = itaacdb;
output reset; output on; screen on;
" ";
"Estimation first two third, italuation first two third";

/****************************************************************************/

 ALLCASES = rows(datamatrix);

 P     =1;                                 /* lag length for lagged psi in ACD model (used as GLOBAL) */
 Q     =1;                                 /* lag length for lagged XI in  ACD model (used as GLOBAL) */

@
  This selects the last third of the data for forecasting purposes
  and also tests on the data
@

 XI    = datamatrix[1:round(allcases*(2/3))-1,7];
 FXI   = xi;

/* Globals needed for Forecasting j.g. November 4, 1999 */

                                           /* This uses the last third of durations for italuation (XI is used as a GLOBAL)*/
 FCASES =rows(FXI);                        /* CASES is used as a GLOBAL in diebold_z                  */
 FMXI   =generate_lagged_xi(FXI,q,fcases); /* Generates a matrix of lagged durations (used as GLOBAL) */


/* Globals for Estimation  j.g. November 4, 1999 */

 CASES =rows(XI);                         /* CASES used for estimation                                            */
 MXI   =generate_lagged_xi(XI,q,cases);   /* Generates a matrix of lagged durations for estimation(used as GLOBAL) */
 MIND_P=genindx_with_cases(2,p,1,cases);  /* Generates an index vector that is only needed if analytical gradients
                                             are supplied for EACD, WACD and BACD, then used as global
                                          */

 EXO    = zeros(cases,1);                             /* 0 = no exogenous regressors in PSI equation: estimation period */
 FEXO   = 0;                             /* same for forecasting period                                    */
 NOEXOG = 0;                             /* signifies number of exogenour regressors */
 data_input = {};                        /* I dont use this matrix to transfer data, I use Glokols (xi, mxi,)
                                            it may be needed, howETer for other models...*/
 let model_specifics = {};               /* I don't need any, you may.... */


sub_aacd         = "AACD";
model            = "BAACD";

_cml_algorithm   = 3;         /* CML settings */
_cml_linesearch  = 1;
/*_cml_gradstep  = 0.01;*/
_use_cml         = 1;
_cml_covpar      = 2;
_cml_gradmethod  = 0;

/*
_uu_ = { 1e-06 1e250 };
_cml_Bounds = ones(rows(model_parameters),2).*_uu_;
_cml_bounds[1,1] = -50;
_cml_bounds[2,1] = -50;
_cml_bounds[8,1]= -5;
/*_cml_bounds[8,2]= 0.9999;*/
_cml_maxtry = 100000;
*/

loadm model_parameters = itapacdb_par;
model_parameters=model_parameters|model_parameters[6];

loadm model_parameters = itlogacdb_par;
model_parameters=model_parameters|0.2|0|0|1;

loadm model_parameters = ETpacdb_par;
model_parameters=model_parameters|0|0|model_parameters[6];

loadm model_parameters = itaseacdb_par;
model_parameters=model_parameters[1:5]|0.0001|model_parameters[6:7]|1;

loadm model_parameters = itlacd1b_par;
model_parameters=model_parameters|0.0001|0|0|0.0001;

loadm model_parameters = itapacdb_par;
model_parameters=model_parameters|model_parameters[6];

loadm model_parameters = itaseacdb_par;
model_parameters=model_parameters[1:5]|0.0001|model_parameters[6:7]|1;

loadm model_parameters = itpacdb_par;
model_parameters=model_parameters|0|0|model_parameters[6];

loadm model_parameters = itapacdb_par;
model_parameters=model_parameters|model_parameters[6];

LET model_parameters= 
             0.0300  
             0.1258  
             0.8443  
             1.4435      
             0.6640  
             0.0093  
            -0.2891    
             0.0098    
             0.0086;

_cml_maxiters = 10000;
_cml_maxtry = 100000;
{itaacdb_par, itaacdb_f0 , g, itaacdb_varcov, itaacdb_retcode} = CML(XI, 0, &li_aacd, model_parameters);
save itaacdb_par;
save itaacdb_f0;
itaacdb_se = sqrt(diag(itaacdb_varcov));
save itaacdb_se;
save itaacdb_retcode;

"Log-Likelihood";
 itaacdb_f0*cases;
"BIC";
-2*itaacdb_f0*cases+ln(cases)*rows(itaacdb_par);
"Parameter estimates and standard errors";
itaacdb_par~itaacdb_se;
